-- by Spee
-- Yes this is mega jank

freeslot(
    "SPR_TEBD",
    "S_TENNA_LOSE1", "S_TENNA_LOSE2", "S_TENNA_LOSE3", "S_TENNA_LOSE4",
    "S_TENNA_FALL",
    "S_TENNA_ARML", "S_TENNA_ARMR",
    "MT_TENNA_ARM", "MT_TENNA_PUPPET"
)

states[S_TENNA_LOSE1] = {sprite = SPR_TEBD, frame = A, tics = 2, nextstate =  S_TENNA_LOSE2}
states[S_TENNA_LOSE2] = {sprite = SPR_TEBD, frame = B, tics = 2, nextstate =  S_TENNA_LOSE3}
states[S_TENNA_LOSE3] = {sprite = SPR_TEBD, frame = C, tics = 2, nextstate =  S_TENNA_LOSE4}
states[S_TENNA_LOSE4] = {sprite = SPR_TEBD, frame = D, tics = 2, nextstate =  S_TENNA_LOSE1}
states[S_TENNA_FALL] = {sprite = SPR_TEBD, frame = E, tics = 500, nextstate = S_NULL}
states[S_TENNA_ARMR] = {sprite = SPR_TEBD, frame = F, tics = -1}
states[S_TENNA_ARML] = {sprite = SPR_TEBD, frame = G, tics = -1}

-- Define puppet actor
mobjinfo[MT_TENNA_PUPPET] = {
    doomednum = -1,
    spawnstate = S_TENNA_LOSE1,
    deathstate = S_NULL,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY
}

-- Define arm actor
mobjinfo[MT_TENNA_ARM] = {
    doomednum = -1,
    spawnstate = S_TENNA_ARML,
    deathstate = S_NULL,
    radius = 8*FRACUNIT,
    height = 8*FRACUNIT,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY
}

-- When the player dies/finishes
addHook("MobjThinker", function(mo)
	if not mo.player then return end
	local p = mo.player
	if skins[p.mo.skin].name ~= "tennahd" then return end

	-- Already spawned puppet? Don't repeat.
	if mo.tennaPuppet then 
		mo.flags2 = $ | MF2_DONTDRAW
		return
	end

	if (p.exiting and K_IsPlayerLosing(p)) or (p.pflags & PF_TIMEOVER) then
		-- Hide player
		mo.flags2 = $ | MF2_DONTDRAW

		-- Spawn puppet and store reference
		local puppet = P_SpawnMobj(mo.x, mo.y, mo.z, MT_TENNA_PUPPET)
		puppet.color = mo.color
		puppet.angle = mo.angle
		puppet.target = mo
		puppet.tennaLoseTimer = 4 * TICRATE
		puppet.tennaLosePhase = 1
		puppet.flags = $ | MF_NOGRAVITY
		puppet.originalX = mo.x
		puppet.originalY = mo.y

		mo.tennaPuppet = puppet
	end
end, MT_PLAYER)

-- Spawn a falling arm
local function spawnTennaArm(mo, side)
    local arm = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_TENNA_ARM)
    arm.color   = mo.color
    arm.state   = (side == "left") and S_TENNA_ARML or S_TENNA_ARMR

    -- Launch direction: HIS left = negative X, HIS right = positive X
    local horizSpeed = 2 * FRACUNIT
    arm.momx = (side == "left") and -horizSpeed or horizSpeed

    -- Random Y momentum for flare
    arm.momy = P_RandomRange(-2, 2) * (FRACUNIT / 4)

    -- Big upward launch
    arm.momz = 8 * FRACUNIT

    arm.armTimer = 3 * TICRATE
    arm.bounces  = 0

    -- Allow it to fall through floor slowly
    arm.flags = $ | MF_NOCLIPHEIGHT
end

addHook("MobjThinker", function(mo)
    mo.tennaLoseTimer = $ - 1

    if mo.tennaLosePhase == 1 then
        if not mo.shakeCounter then
            mo.shakeCounter = 0
            mo.shakeAmplitude = 10 * FRACUNIT
        end

        -- Slow left-right shaking with decreasing amplitude
        if mo.shakeAmplitude > 0 then
            local direction = (mo.shakeCounter % 8 == 0) and 1 or -1
            local dx = direction * mo.shakeAmplitude
            local dy = 3 * FRACUNIT  -- no vertical shake, but you can add small random if you want
            P_SetOrigin(mo, mo.originalX + dx, mo.originalY + dy, mo.z)

            -- Reduce amplitude every two ticks (after a left-right pair)
            if mo.shakeCounter % 8
			== 1 then --nice formation
                mo.shakeAmplitude = mo.shakeAmplitude - FRACUNIT
                if mo.shakeAmplitude < 0 then mo.shakeAmplitude = 0 end
            end

            mo.shakeCounter = mo.shakeCounter + 1
        else
            P_SetOrigin(mo, mo.originalX, mo.originalY, mo.z)
        end
		
        if mo.tennaLoseTimer == 135 then
            if not mo.armsSpawned then
                spawnTennaArm(mo, "left")
                spawnTennaArm(mo, "right")
                mo.armsSpawned = true
            end
        end

        if mo.tennaLoseTimer == 1 * TICRATE then
            mo.tennaLosePhase = 2
            mo.tennaLoseTimer = 4 * TICRATE
            mo.state = S_TENNA_FALL
            mo.flags = $ & ~MF_NOGRAVITY
            mo.momz = -FRACUNIT / 1
        end
	end
end, MT_TENNA_PUPPET)

addHook("MobjThinker", function(mo)
    mo.armTimer = $ - 1
    if mo.armTimer <= 0 then
        P_RemoveMobj(mo)
        return
    end

    -- Very slow gravity
    mo.momz = $ - FRACUNIT / 500 -- :)

    local newX = mo.x + mo.momx
    local newY = mo.y + mo.momy
    local newZ = mo.z + mo.momz

    -- No bounce, just gently fall through the floor
    P_SetOrigin(mo, newX, newY, newZ)
end, MT_TENNA_ARM)